(** A graph-tableau-based decision procedure framework for coalgebraic logics.
    @author Florian Widmann
 *)


type sortTable = (CoAlgMisc.functors * int list) array

type nomTable = string -> CoAlgFormula.sort option

type assumptions = CoAlgFormula.sortedFormula list

type input = sortTable * nomTable * assumptions * CoAlgFormula.sortedFormula

val isSat : ?verbose:bool -> sortTable -> (string -> CoAlgFormula.sort option) ->
  CoAlgFormula.sortedFormula list -> CoAlgFormula.sortedFormula -> bool
