
(* Some basic utilities as they are known from haskell prelude and so on... *)

module TArray : sig
    val all : ('a -> bool) -> 'a array -> bool
    val any : ('a -> bool) -> 'a array -> bool
    val elem : 'a -> 'a array -> bool
    val included : 'a array -> 'a array -> bool
    val to_string : ('a -> string) -> 'a array -> string
    val uniq : 'a array -> 'a array (* delete consecutive duplicates *)
end

module TList : sig
    val zip : ('a list) -> ('b list) -> ('a * 'b) list
    val powerset : ('a list) -> ('a list list)
    val prod : ('a list) -> ('b list) -> (('a * 'b) list)
    val empty : ('a list) -> bool
end

val cl_get_agents : unit -> int array
val cl_set_agents : int array -> unit

val intlist_of_string : string -> int list

val compose : ('b -> 'c) -> ('a -> 'b) -> ('a -> 'c)
val flip : ('a -> 'b -> 'c) -> ('b -> 'a -> 'c)
val eval : 'a -> ('a -> 'b) -> 'b
val id : 'a -> 'a
val foreach_l : ('a list) -> ('a -> unit) -> unit
val repeat : int -> (unit -> unit) -> unit
val (<<) : ('b -> 'c) -> ('a -> 'b) -> ('a -> 'c)

